/*****************************************************
Chip type           : ATmega2560
Program type        : Application
Clock frequency     : 3,686400 MHz
Memory model        : Small
External RAM size   : 0
Data Stack size     : 2048
*****************************************************/

#include <mega2560.h>

#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7


#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)


char len;
flash char encodeTable[] =
{'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e',
'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u'};
volatile char sms[];
char stroka[]={0xB1,0x9A,0xFF,0x2B,0x79,0xEE,0x31,0x46,0x32,0x2E,0x83,0xDD,0x1B,0x0,0x0,
               0x01,0x0,0x0,0x9A,0x7E,0x09,0x00,0x00,0x00,0x0C,0x01,0x00,0x00,0x00,0x00,0xFE};

// Get a character from the USART3 Receiver
#pragma used+
char getchar3(void)
{
char status,data;
while (1)
      {
      while (((status=UCSR3A) & RX_COMPLETE)==0);
      data=UDR3;
      if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
         return data;
      };
}
#pragma used-

// Write a character to the USART3 Transmitter
#pragma used+
void putchar3(char c)
{
while ((UCSR3A & DATA_REGISTER_EMPTY)==0);
UDR3=c;
}
#pragma used-
/////////////////////////////////////////////////////////////////////////////
//   UART3 - Telit
#pragma used+
void send(char *mas)
{
char data;
while (*mas)
  {
    data = *mas++;
    putchar3(data);
  }

 }
#pragma used-
/////////////////////////////////////////////////////////////////////////////
char EncodeData(char data[])
{
char len0, i, index;
char a0, a1, a2;
char b0, b1, b2, b3;

len0=len/3-1;
//putchar3(len0);
for(i=0;i<len0; i=i+1)
{
index=i*3;
a0 = data[index];
  putchar3(a0);
  putchar3(index);
  putchar3('\n');

index=i*3+1;
a1 = data[index];
  putchar3(a1);
  putchar3(index);
  putchar3('\n');

index=i*3+2;
a2 = data[index];
  putchar3(a2);
  putchar3(index);
  putchar3('\n');

b0 = a0&0x3F;
b1 = ((a1&0x0F)<<2)|(a0>>6);
b2 = ((a2&0x03)<<4)|(a1>>4);
b3 = a2>>2;

sms[i*4]=encodeTable[b0];
sms[i*4+1]=encodeTable[b1];
sms[i*4+2]=encodeTable[b2];
sms[i*4+3]=encodeTable[b3];

}
/*
if(len%3==2)
{
 a0=data[len-1];
 a1=data[len];

 b0=a0&(0x3F);
 b1=((a1&0x0F)<<2)|(a0>>6);
 b2=a1>>4;

 sms[i*4+4]=encodeTable[b0];
 //index++;
 sms[i*4+5]=encodeTable[b1];
 //index++;
 sms[i*4+6]=encodeTable[b2];
 //index++;
}
if(len%3==1)
{
 a0=data[len];

 b0=a0&0x3F;
 b1=a0>>6;

 sms[i*4+4]=encodeTable[b0];
 //index++;
 sms[i*4+5]=encodeTable[b1];
 //index++;
}
*/
return (*sms);
}
// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
//////////////////////////////////////////////////////////////////////
// USART3 initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART3 Receiver: On
// USART3 Transmitter: On
// USART3 Mode: Asynchronous
// USART3 Baud Rate: 115200
UCSR3A=0x00;
UCSR3B=0x18;
UCSR3C=0x06;
UBRR3H=0x00;
UBRR3L=0x01;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
ADCSRB=0x00;

        len=sizeof(stroka);
        send(stroka);
        putchar3('\n');
        EncodeData(stroka);
        send(sms);
        putchar3('\n');

while (1)
      { //send(data);

      };
}
